using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace WeaponMod
{
    public class WeaponMod
    {
        public static void Main()
        {

        CategoryBuilder.Create("Star Wars Blasters", "",ModAPI.LoadSprite("blasters.png", 1.6f));



        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "Modified DC-15",
                    NameToOrderByOverride = "[1] Galactic Republic",
                    DescriptionOverride = "The DC-15 heavy blaster rifle and it was one of the standard-issue weapons of the Galactic Republic's clone troopers. This is a modified version that was used by militia and smugglers after the Clone Wars.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DC-15_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        
                        //things from the ingame blaster
                               
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject); // removes large middle line
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject); // removes medium middle line
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject); // removes right line (when the gun is spawned facing right)
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject); // removes the red glow                                                                           
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject); // removes mazzle flash  (this is the reason why the gun won't be copied or saved). why it does that to a blaster and not to a firearm? because the way i think is. is that the muzzle flash on the firearms is a background element, but the muzzle flash on the blasters in a element on the weapon itself, (zooi why?)
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject); // removes left line (when the gun is spawned facing right)
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject); // removes small middle line
  
                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DC15.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DC-15.png", 6.8f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.15f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.439f, 0.085f);
                        Instance.FixColliders();                                       //left,right     up,down
                        
                    }
                }
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "Modified DC-15S",
                    NameToOrderByOverride = "[1] Galactic Republic",
                    DescriptionOverride = "The DC-15S was the blaster carbine variant of DC-15A blaster rifle. This weapon was carried by the clone troopers of the Galactic Republic. It was later modified for use by smugglers and militia. (Copyable)",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DC-15S_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DC15S.wav"),
                            ModAPI.LoadSound("Sounds/DC15S-2.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DC-15S.png", 5f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.20f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.469f, 0.09f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();                

                    }
                }
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "DC-17",
                    NameToOrderByOverride = "[1] Galactic Republic",
                    DescriptionOverride = "The DC-17 heavy blaster pistol was wielded by the clone troopers of the Grand Army of the Galactic Republic during the Clone Wars. It was also saw use under some officers of the Galactic Empire.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DC-17_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DC17.wav")                      
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DC-17.png", 5.3f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.475f, 0.0906f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();            

                    }
                }
            );
                   
        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "Valken-38x",
                    NameToOrderByOverride = "[1] Galactic Republic",
                    DescriptionOverride = "The Valken-38x was a model of longblaster that was manufactured for high precision and power over long ranges. It was utilized by the Galactic Republic during the Clone Wars. It was also used and modified by militia and bounty hunters.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("Valken_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/Valken.wav"),
                            ModAPI.LoadSound("Sounds/Valken-2.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Valken-38x.png", 6.4f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.47f, 0.094f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();                

                    }
                }
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "Valken-38x (Bipod)",                  
                    NameToOrderByOverride = "[1] Galactic Republic",
                    DescriptionOverride = "The Valken-38x was a model of longblaster that was manufactured for high precision and power over long ranges. It was utilized by the Galactic Republic during the Clone Wars. (With bipod)",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("Valken(Bipod)_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/Valken.wav"),
                            ModAPI.LoadSound("Sounds/Valken-2.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Valken-38x (Bipod).png", 6.4f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.475f, 0.094f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();                

                    }
                }
            );                        

          ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "Z-6 (non)rotary Blaster Cannon",                  
                    NameToOrderByOverride = "[1] Galactic Republic",
                    DescriptionOverride = "The Z-6 rotary blaster cannon was a powerful rotating blaster cannon chaingun and was used during the Clone Wars and the Galactic Civil War.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("Z6_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/Z6.wav"),
                            ModAPI.LoadSound("Sounds/Z6-2.wav"),
                            ModAPI.LoadSound("Sounds/Z6-3.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Z-6.png", 9.0f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.075f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.467f, 0.08f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();                

                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "DC-17m ICWS (Pistol)",                  
                    NameToOrderByOverride = "[2] Galactic Republic Commandos",
                    DescriptionOverride = "The DC-17m Interchangeable Weapon System (DC-17m ICWS) was a configurable combat weapons system used by the clone commandos of the Galactic Republic.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DC-17mP_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DC17mP.wav") 
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DC-17mP.png", 9.4f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.475f, 0.096f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();                

                    }
                }
            ); 

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "DC-17m ICWS (Blaster)",                  
                    NameToOrderByOverride = "[2] Galactic Republic",
                    DescriptionOverride = "The DC-17m Interchangeable Weapon System (DC-17m ICWS) was a configurable combat weapons system used by the clone commandos of the Galactic Republic.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DC-17m_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DC17m.wav")/*,
                            ModAPI.LoadSound("Sounds/DC17m-1.wav"),        (scraped)
                            ModAPI.LoadSound("Sounds/DC17m-2.wav"),
                            ModAPI.LoadSound("Sounds/DC17m-3.wav")
                            ModAPI.LoadSound("Sounds/DC17m-4.wav")*/
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DC-17m.png", 17.0f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.14f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.469f, 0.096f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();                

                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "DC-17m ICWS (Sniper)",                  
                    NameToOrderByOverride = "[2] Galactic Republic Commandos",
                    DescriptionOverride = "The DC-17m Interchangeable Weapon System (DC-17m ICWS) was a configurable combat weapons system used by the clone commandos of the Galactic Republic.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DC-17mS_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DC17mS.wav") 
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DC-17mS.png", 17.0f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.445f, 0.097f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();                

                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Grenade Launcher"),
                    NameOverride = "DC-17m ICWS (Grebade Launcher)",                  
                    NameToOrderByOverride = "[2] Galactic Republic Commandos",
                    DescriptionOverride = "The DC-17m Interchangeable Weapon System (DC-17m ICWS) was a configurable combat weapons system used by the clone commandos of the Galactic Republic.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DC-17mGL_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DC-17mGL.png", 17.0f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().barrelPosition = new Vector2(0.42f, 0.143f);
                        Instance.FixColliders();                

                    }
                }
            ); 


        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "E-5",
                    NameToOrderByOverride = "[3] Confederacy of Independent Systems",
                    DescriptionOverride = "The E-5 was adapted for use by B1-series battle droids and Droid commandos, who used it throughout the Clone Wars. (Copyable)",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("E-5_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            /*ModAPI.LoadSound("Sounds/E5.wav"),*/


                           ModAPI.LoadSound("Sounds/E5-2.wav")
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/E-5.png", 5.5f); 
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.478f, 0.1015f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.22f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();                             

                    }
                }
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "E-5S",
                    NameToOrderByOverride = "[3] Confederacy of Independent Systems",
                    DescriptionOverride = "The E-5s sniper rifle was used by the Battle droid assassins of the Trade Federation and the Separatist Droid Army.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("E-5S_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/E5S.wav")
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/E-5S.png", 7.5f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.468f, 0.085f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();                             

                    }
                }
            );

                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "A280",
                    NameToOrderByOverride = "[4] Rebel Alliance",
                    DescriptionOverride = "The A280 blaster rifle was a type of blaster rifle mostly used by troopers of the Rebel Alliance and the soldiers of the New Republic.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("A280_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/A280C.wav"),
                            ModAPI.LoadSound("Sounds/A280C-2.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/A280.png", 11.6f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.465f, 0.09f);        // burst not work :(
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();

                    }
                }
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "A280-CFE",
                    NameToOrderByOverride = "[4] Rebel Alliance",
                    DescriptionOverride = "The A280-CFE is essentially an accurized version of the A280 and A280C blasters that has been outfitted to work as a marksman's rifle.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("A280CFE_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/A280CFE-s.wav"),
                            ModAPI.LoadSound("Sounds/A280CFE-s2.wav")                    
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/A280CFE.png", 10.5f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.487f, 0.091f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();            

                    }
                }
            );              

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "A280-CFE (pistol variant)",
                    NameToOrderByOverride = "[4] Rebel Alliance",
                    DescriptionOverride = "The A280-CFE convertible heavy blaster pistol, was a modular version of the A280 blaster rifle. It featured a core pistol that could be reconfigured into an assault rifle or sniper rifle.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("A280-CFE_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/A280CFE.wav"),
                            ModAPI.LoadSound("Sounds/A280CFE-2.wav")                    
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/A280-CFE.png", 14.6f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.477f, 0.088f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();            

                    }
                }
            );  

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "A280C",
                    NameToOrderByOverride = "[4] Rebel Alliance",
                    DescriptionOverride = "Before the Clone Wars, the A280C was the standard-issue infantry rifle for many planetary defense forces and private militias. It was later used by the Alliance to Restore the Republic. (Copyable)",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("A280C_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/A280C.wav"),
                            ModAPI.LoadSound("Sounds/A280C-2.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/A280C.png", 11.1f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.464f, 0.0805f);                        
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.18f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();

                    }
                }
            );                      

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "DH-17",
                    NameToOrderByOverride = "[4] Rebel Alliance",
                    DescriptionOverride = "The DH-17 blaster pistol was commonly used by soldiers of the Rebel Alliance for conflicts aboard starships, and sometimes the officers of the Galactic Empire carried it.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DH-17_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DH17-2.wav"),
                            ModAPI.LoadSound("Sounds/DH17-3.wav")
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DH-17.png", 9.2f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.478f, 0.0903f);                        
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();

                    }
                }
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "E-11",
                    NameToOrderByOverride = "[5] Galactic Empire",
                    DescriptionOverride = "The E-11 blaster rifle served as the standard issue weapon of Imperial stormtroopers. (Copyable)",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("E-11_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/E11.wav"),
                            ModAPI.LoadSound("Sounds/E11-2.wav")
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/E-11.png", 4.4f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.20f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.4675f, 0.078f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();       

                    }
                }
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "E-11D",
                    NameToOrderByOverride = "[5] Galactic Empire",
                    DescriptionOverride = "E-11D blaster rifle was used by the Galactic Empire's death troopers. (Copyable)",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("E-11D_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/E11D.wav"),
                            ModAPI.LoadSound("Sounds/E11D-2.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/E-11D.png", 10.3f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.22f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.465f, 0.098f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();
                    }        
                }
            );                

           ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "EC-17",
                    NameToOrderByOverride = "[5] Galactic Empire",
                    DescriptionOverride = "The EC-17 hold-out blaster, was a standard-issue hold-out blaster pistol for Imperial scout troopers and patrol troopers.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("EC-17_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/EC17.wav"),
                            ModAPI.LoadSound("Sounds/EC17-2.wav")
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/EC-17.png", 16.2f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.13f;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.484f, 0.0883f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();
                    }
                }   
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "TL-50",
                    NameToOrderByOverride = "[5] Galactic Empire",
                    DescriptionOverride = "The TL-50 Heavy Repeater was used by special forces of the Galactic Empire. (Copyable)",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("TL-50_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/TL50.wav"),
                            ModAPI.LoadSound("Sounds/TL50-2.wav"),
                            ModAPI.LoadSound("Sounds/TL50-3.wav")
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/TL-50.png", 10.9f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.14f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.455f, 0.115f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();
                    }
                }   
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "SE-14r",
                    NameToOrderByOverride = "[5] Galactic Empirer",
                    DescriptionOverride = "SE-14r blaster pistol was a light repeating blaster and it was used by personnel of the Galactic Empire, including the Imperial Intelligence's death troopers, regular stormtroopers, and some officers.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("SE-14r_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/SE14R.wav"),
                            ModAPI.LoadSound("Sounds/SE14R-2.wav")                     
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/SE-14r.png", 15.8f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.458f, 0.0898f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();            

                    }
                }
            ); 

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "E-Web Heavy Repeating Blaster",                  
                    NameToOrderByOverride = "[5] Galactic Empire",
                    DescriptionOverride = "The E-Web heavy repeating blaster cannon, was the most powerful heavy repeating blaster cannon in the Imperial arsenal and commonly used by the Galactic Empire.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("EWEB_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/EWEB.wav"),
                            ModAPI.LoadSound("Sounds/EWEB-2.wav"),
                            ModAPI.LoadSound("Sounds/EWEB-3.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/E-WEB.png", 9.6f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.13f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.47f, 0.095f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();                

                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "E-WEB Tripod",                  
                    NameToOrderByOverride = "[5] Galactic Empire",
                    DescriptionOverride = "Tripod for the E-WEB. (You can attach the EWeb with a 'pin')",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("EWEB-Tripod_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Tripod_EWEB.png", 8.9f);

                        Instance.FixColliders();                

                    }
                }
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "DLT-19",
                    NameToOrderByOverride = "[5] Galactic Empire",
                    DescriptionOverride = "The DLT-19 heavy blaster rifle and were used by regular stormtroopers and Heavy Weapons Stormtroopers of the Galactic Empire. (Copyable)",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DLT-19_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DLT19.wav"),
                            ModAPI.LoadSound("Sounds/DLT19-2.wav"),
                            ModAPI.LoadSound("Sounds/DLT19-3.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DLT-19.png", 7.5f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.12f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.465f, 0.0998f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();
                    }
                } 
            );          

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "DLT-19 (Bipod)",
                    NameToOrderByOverride = "[5] Galactic Empire",
                    DescriptionOverride = "The DLT-19 heavy blaster rifle and were used by regular stormtroopers and Heavy Weapons Stormtroopers of the Galactic Empire. (With Bipod)",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DLT-19(Bipod)_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DLT19.wav"),
                            ModAPI.LoadSound("Sounds/DLT19-2.wav"),
                            ModAPI.LoadSound("Sounds/DLT19-3.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DLT-19 (Bipod).png", 7.5f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.12f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.465f, 0.0905f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();
                    }
                } 
            );                        
        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "NT-242c (Prototype)",
                    NameToOrderByOverride = "[6] Other",
                    DescriptionOverride = " This is a prototype version of the NT-242 which has less power and accuracy compare to its predecessor that was considered a tank buster and one of the heaviest longblasters.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("NT-242_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/NT242.wav"),
                            ModAPI.LoadSound("Sounds/NT242-2.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/NT-242.png", 9.7f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.465f, 0.103f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();  
                    }
                }
            );   

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "DLT-19x",
                    NameToOrderByOverride = "[5] Galactic Empire",
                    DescriptionOverride = "The DLT-19x was a blaster rifle, and a variation of the DLT-19 heavy blaster rifle. It was a weapon of choice for many snipers, and was very effective and silent.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DLT-19x_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DLT19X.wav"),
                            ModAPI.LoadSound("Sounds/DLT19X-2.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DLT-19x.png", 7.5f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.4368f, 0.087f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();  
                    }
                }
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "F-11D",
                    NameToOrderByOverride = "[6] First Order",
                    DescriptionOverride = "The F-11D blaster rifle was served as the standard issue weapon of First Order stormtroopers.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("F-11D_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/F11D.wav"),
                            ModAPI.LoadSound("Sounds/F11D-2.wav")
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/F-11D.png", 12.9f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.20f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.433f, 0.078f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();       

                    }
                }
            );    

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "SE-44C",
                    NameToOrderByOverride = "[6] First Order",
                    DescriptionOverride = "The SE-44C blaster pistol was used by officers of the First Order.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("SE-44C_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/SE44C.wav"), 
                            ModAPI.LoadSound("Sounds/SE44C-2.wav")
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/SE-44C.png", 21.5f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.20f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = false;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.452f, 0.078f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();       

                    }
                }
            );   

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "FWMD-10",
                    NameToOrderByOverride = "[6] First Order",
                    DescriptionOverride = "The FWMB-10K was a heavy blaster used by the First Order. A smaller variant of the FWMB-10 repeating blaster.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("FWMB-10K_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/FWMB10K.wav"),
                            ModAPI.LoadSound("Sounds/FWMB10K-2.wav")
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/FWMB-10K.png", 9.9f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.12f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.4523f, 0.085f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();       

                    }
                }
            );      
/*
        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "DLT-19D",
                    NameToOrderByOverride = "[6] First Order",
                    DescriptionOverride = "The DLT-19D heavy blaster rifle was a long-range heavy blaster rifle, used by some of the Galactic Empire's death troopers. Years later, the DLT-19D was used by First Order Specialist stormtroopers in the same color scheme.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("F-11D_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/SE44C.wav")
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/SE-44C.png", 12.9f);
                        Instance.GetComponent<BlasterBehaviour>().Interval = 0.20f;
                        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.433f, 0.078f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();       

                    }
                }
            );   */                                               

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Cycler Rifle",
                    NameToOrderByOverride = "[8] Other",
                    DescriptionOverride = "Cycler rifles were crude yet reliable rifles designed to fire solid projectiles. Used primarily by primitive cultures and hunters.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("Cycler_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {                        
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/Cycler.png", 8.9f);
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(1.156f, 0.1255f);


                        Cartridge customCartridge = ModAPI.FindCartridge("50 BMG");
                        customCartridge.name = "Slug"; // i think those weapons fire a slug?
                        customCartridge.Damage *= 11.5f; 
                        customCartridge.StartSpeed *= 10.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.3f; 
                        customCartridge.Recoil *= 0.5f; 
                        customCartridge.ImpactForce *= 3.5f; 
                        firearm.Cartridge = customCartridge;

                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/Cycler.wav"),
                            ModAPI.LoadSound("Sounds/Cycler-2.wav"),
                            ModAPI.LoadSound("Sounds/Cycler-3.wav")
                            
                        };

                        Instance.FixColliders();  
                    }
                }                  
            ); 

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "DL-18",
                    NameToOrderByOverride = "[8] Other",
                    DescriptionOverride = "The DL-18 blaster pistol was a model of blaster pistol commonly used throughout the galaxy, particularly by bounty hunters and smugglers.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DL-18_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DL18.wav"),
                            ModAPI.LoadSound("Sounds/DL18-2.wav")
                            
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DL-18.png", 17.5f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.483f, 0.0855f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();  
                    }
                }
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "DL-44",
                    NameToOrderByOverride = "[8] Other",
                    DescriptionOverride = "The DL-44 heavy blaster pistol was a powerful sidearm from the time of the Galactic Republic through the Galactic Civil War. It was used by Tobias Beckett before he gave it to Han Solo.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("DL-44_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/DL44.wav"),
                            ModAPI.LoadSound("Sounds/DL44-2.wav")                   
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/DL-44.png", 12.3f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.480069696969696969696969696969f, 0.0877f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();            

                    }
                }
            );

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "IB-94",
                    NameToOrderByOverride = "[8] Other",
                    DescriptionOverride = "The IB-94 blaster pistol was used by Din Djarin that served as his primary sidearm.",
                    CategoryOverride = ModAPI.FindCategory("Star Wars Blasters"),
                    ThumbnailOverride = ModAPI.LoadSprite("IB-94_View.png", 5f),

                    AfterSpawn = (Instance) =>
                    {
                        
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(0).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(1).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(2).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(3).gameObject);
                        //UnityEngine.Object.Destroy(Instance.transform.GetChild(4).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(5).gameObject);
                        UnityEngine.Object.Destroy(Instance.transform.GetChild(6).gameObject);

                        var firearm = Instance.GetComponent<BlasterBehaviour>();

                        firearm.Clips = new AudioClip[]
                        {
                            ModAPI.LoadSound("Sounds/IB94.wav")
                                                 
                        };
                        
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sprites/IB-94.png", 13.8f);
                        Instance.GetComponent<BlasterBehaviour>().barrelPosition = new Vector2(0.4805f, 0.0895f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;
                        Instance.FixColliders();            

                    }
                }
            );

        }        
    }
}